
.. _htmx_flask_python_course:

==================================================================================
**HTMX + Flask: Modern Python Web Apps, Hold the JavaScript**
==================================================================================

- :ref:`mickael_kennedy`
- https://github.com/talkpython/htmx-python-course
- https://github.com/talkpython/htmx-python-course/commits/main
- https://github.com/talkpython/htmx-python-course/graphs/contributors
- https://training.talkpython.fm/courses/htmx-flask-modern-python-web-apps-hold-the-javascript
- https://training.talkpython.fm/courses/htmx-flask-modern-python-web-apps-hold-the-javascript#course_outline

Course Summary
=================

htmx is one of the hottest properties fire in web development today, and
for good reason.

This framework, along with the libraries and techniques introduced in
this course, will have you writing the best Python web apps you've ever
written: clean, fast, and interactive without all that frontend overhead.

If you are a Python web developer that has wanted to build more dynamic,
interactive apps, but just don't want to (or can't) write a significant
portion of your app in a rich frontend JavaScript framework, you'll
absolutely love htmx.

This library lets you write Python code you love and still add that
client-side interactive aspect.


What's this course about and how is it different ?
=====================================================

htmx is a very compelling technology. It's one of the first legitimate
libraries that delivers on the promise of dynamic, interactive web applications
without complex JavaScript.

htmx allows us to write server-side code in any language (Python in our case)
and, through a few simple HTML attributes, bring our pages to life.

This is the only course (that we're aware of) that shows you the full
lifecycle of building Python and Flask-based applications centered
around htmx.

Unlike basic tutorials where you'll find only just quick coverage of a
simple feature, we take a full-fledged web app and extend it by adding
three real-world features all building upon htmx.

Moreover, we show you the right way to use htmx with Flask and Python.
The resulting code is incredibly clean and would impress almost any
professional web developer.

What topics are covered
=============================

In this course, you will:

- See how htmx differs from common JavaScript front-end frameworks such
  as Vue and React.
- Understand the server-side exchange enabled by htmx attributes
  (e.g. hx-trigger).
- Add click to edit to an existing data-driven Flask application.
- Learn about the jinja-partials package to refactor our jinja2 templates
  (with or without htmx).
- Add deep linking to our dynamic web application, allowing us to share
  links into interactive segments.
- Add active search to an existing data-driven Flask application.
- Implement browser history for htmx actions (allowing back and forth navigation).
- Add infinite scroll to our app.
- Distinguish between full page requests and partial htmx requests within
  a single view method in Flask.
- And lots more
